require "src/player"
require "src/gradient"
require "src/cloud"
require "src/menu"
require "src/level"
require "levelMaps/level_test"

function love.load()
    world = love.physics.newWorld(0, 0)
    world:setCallbacks(beginCon, endCon)

    virtual_width = 1280 / 4
    virtual_height = 780 / 4
    window_width = virtual_width *  2
    window_height = virtual_height * 2
    love.window.setMode(window_width, window_height)
    love.graphics.setDefaultFilter("nearest", "nearest")
    menu = menu.new({{x = virtual_width / 2 - 30 / 2, y = virtual_height / 3 - 15 /2, width = 30, height = 15, selected = false, screen = "gamePlay"}, {x = virtual_width / 2 - 30 / 2, y = virtual_height / 1.5 - 15/2, width = 30, height = 15, selected = false, screen = "options"} }, {0.8, 1, 0.3, 1})
    p = Player.new(0, 0)
    g = gradient.new()
    Clouds = {}
    img = love.graphics.newImage("art/spritesheet.png")
    cloudMaker()
    l = Level.new(0, 0, 27, 12, 16, 16, img, level_test.map, level_test.collision, entities) 
    state = "start"
end

function love.update(dt)
    fps = love.timer.getFPS()
    if state == "start" then 
        menu:update()
    end
    if state == "gamePlay" then 
        p:update(dt)
        world:update(dt)
        for i, c in ipairs(Clouds) do 
            c:update(dt)
        end
    end
end

function love.draw()
   love.graphics.scale(2, 2)
    if state == "start" then 
       menu:draw()
    end
    if state == "gamePlay" then 
        love.graphics.setBackgroundColor(1, 1, 1)
        g:draw()
        for i, c in ipairs(Clouds) do 
            c:draw()
        end
        love.graphics.push()
        love.graphics.translate(-p.x + virtual_width / 2, -p.y + virtual_height / 2)
        p:draw()
        love.graphics.setColor(1, 1, 1, 1)

        l:draw()

        love.graphics.pop()
        love.graphics.setColor(1, 1, 1, 1)
        love.graphics.print("FPS:" .. fps)
    end
    
end

function cloudMaker()
    local total = 0
    local max = 4
    while total < max  do 
        c = cloud.new(love.math.random(0, virtual_width - 9*3), love.math.random(0, virtual_height / 3))
        table.insert(Clouds, c)
        total = total + 1
    end
end

function love.keypressed(key)
    p:jump(key)
end

function beginCon(a, b, collision)
    p:beginCon(a, b, collision)
end

function endCon(a, b, collision) 
    p:endCon(a, b, collision)
end
