Level = {}
Level.__index = Level

function Level.new(x, y, map_width, map_height,tile_width , tile_height, image, tiles, collision, entities) 
    local instance = setmetatable({}, Level) 
    instance.x = x
    instance.y = y
    instance.map = {}
    instance.map.width = map_width
    instance.map.height = map_height
    instance.map.tile_width = tile_width 
    instance.map.tile_height = tile_height
    instance.map.tiles = tiles
    instance.map.spritebatch = love.graphics.newSpriteBatch(image)
    instance.map.image = image
    instance.map.collision = collision
    instance.map.quads = {}
    for y=1, instance.map.image:getHeight() / instance.map.tile_height do 
        for x=1, instance.map.image:getWidth() / instance.map.tile_width do 
            q = love.graphics.newQuad((x-1)*instance.map.tile_width, (y-1)*instance.map.tile_height, instance.map.tile_width, instance.map.tile_height, instance.map.image:getWidth(), instance.map.image:getHeight())
            table.insert(instance.map.quads, q)
        end
    end
    for y, xs in ipairs(instance.map.tiles) do 
        for x, value in ipairs(xs) do 
            if value > 0 then 
                print("Theres one of 4")
                instance.map.spritebatch:add(instance.map.quads[value], ( x-1) * instance.map.tile_width, (y-1) * instance.map.tile_height )
            end
        end
    end

    instance.coll = {}
    instance.coll.bodys = {}
    instance.coll.shapes = {}
    instance.coll.fixture = {}

    for i, c in ipairs (instance.map.collision) do 
        local b = love.physics.newBody(world, c.x + instance.x - c.width / 2,  c.y + instance.y - c.height / 2)
        local s = love.physics.newRectangleShape(c.width * instance.map.tile_width, c.height * instance.map.tile_height)
        local f = love.physics.newFixture(b, s)
        table.insert(instance.coll.bodys, b)
        table.insert(instance.coll.shapes, s)
        table.insert(instance.coll.fixture, f)
    end

    return instance
end 

function Level:draw()
    love.graphics.draw(self.map.spritebatch, self.x, self.y)
    for i, c in ipairs (self.map.collision) do 
        love.graphics.rectangle("fill", c.x - c.width / 2, c.y - c.height / 2, c.width * self.map.tile_width, c.height * self.map.tile_height)
    end
end