menu = {}
menu.__index = menu 

function menu.new(buttons, color)
    local instance = setmetatable({}, menu)
    instance.buttons = buttons
    instance.total_buttons = 0
    instance.color = color
    for i, b in ipairs(instance.buttons) do 
        instance.total_buttons = instance.total_buttons + 1
    end
    return instance
end

function menu:update(dt)
    self:select()
end

function menu:draw()
    for i=1, self.total_buttons do 
        if  self.buttons[i].selected == true then 
            self.color[4] = 0.7
        else 
            self.color[4] = 1 
        end
        love.graphics.setColor(unpack(self.color))
        love.graphics.rectangle("fill",  self.buttons[i].x, self.buttons[i].y, self.buttons[i].width, self.buttons[i].height)
    end
end

function menu:select()
    self.color[4] = 1
    local mx, my = love.mouse.getX() / 2, love.mouse.getY() / 2
    for i, c in ipairs(self.buttons) do 
        if mx > c.x and mx < c.x + c.width and my > c.y and my < c.y + c.height then  
            c.selected = true
            if love.mouse.isDown(1) then 
                state = c.screen
            end
        else 
            c.selected = false
        end
    end

end